local Alert_Variables={Alerts = {},Active=false,Players={},Message=""}
local Vote_Variables={Vote={},VoteCount=0,Voted={},VoteTimer=0}
local availablePlayers = {(UnitName("Player").."-"..GetRealmName())}
local CheckOffline_Variables={Old={},New={}}
local SystemActive = true
local useRaidWarning = true
local playersInAshran={}
local InAshran=false

local AshranAlert, events = CreateFrame("Frame"), {};
function events:PLAYER_LOGIN()
	if (not IsAddonMessagePrefixRegistered("AshranAlert")) then
		RegisterAddonMessagePrefix("AshranAlert")
    end
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "PARTY")
	end
	UpdatePlayers()
	if(GetZoneText()=="Ashran")then
		InAshran=true
	end
end
function events:GROUP_JOINED()
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "PARTY")
	end
	UpdatePlayers()
end
function events:GROUP_ROSTER_UPDATE()
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "UpdatePlayers", "PARTY")
	end
	UpdatePlayers()
end
function events:CHAT_MSG_ADDON(msgPrefix,msgMessage,msgChannel,msgSender)
	if (msgSender~=nil and msgSender~=(UnitName("Player").."-"..GetRealmName()) and msgMessage=="UpdatePlayers" and msgPrefix=="AshranAlert") then
			UpdatePlayers()
	elseif (msgSender~=nil and msgSender~=(UnitName("Player").."-"..GetRealmName()) and msgMessage=="" and msgPrefix=="AshranAlert") then
		if (not setContains(availablePlayers,msgSender)) then
			SendAddonMessage("AshranAlert", "", "WHISPER", msgSender)
			table.insert(availablePlayers, msgSender)
			table.sort(availablePlayers)
		end
	elseif (msgSender~=nil and msgSender~=(UnitName("Player").."-"..GetRealmName()) and msgMessage=="DeleteMe" and msgPrefix=="AshranAlert") then
		for i = 1,#Alert_Variables.Alerts do
			for x = 1, #Alert_Variables.Alerts[i].Players do
				if (Alert_Variables.Alerts[i].Players[x]==msgSender) then
					table.remove(Alert_Variables.Alerts[i].Players, x)
				end
			end
		end
		
		if(Alert_Variables.Players~=nil and #Alert_Variables.Players>0)then
			for x = 1, #Alert_Variables.Players do
				if (Alert_Variables.Players[x]==msgSender) then
					table.remove(Alert_Variables.Players, x)
				end
			end
			
			if(Alert_Variables.Active)then
				GetPlayerVote()
			end
		end
		
	elseif (msgSender~=nil and msgPrefix=="AshranAlert" and not setContains({"UpdatePlayers","DeleteMe",""},msgMessage) and not setContains(Vote_Variables.Voted,msgSender)) then
		local name = string.sub(msgMessage,1,string.find(msgMessage,",")-1)
		if(not Vote_Variables.Vote[name]) then
			Vote_Variables.Vote[name]=1
		else
			Vote_Variables.Vote[name]=Vote_Variables.Vote[name]+1
		end
		Vote_Variables.VoteCount=Vote_Variables.VoteCount+1
		table.insert(Vote_Variables.Voted, msgSender)
		
		if(Alert_Variables.Active and Vote_Variables.VoteCount==#playersInAshran) then
			Alert_Variables.Active=false
			FinalizeVote(string.sub(msgMessage,string.find(msgMessage,",")+1))
		end
	end
end
function events:CHAT_MSG_MONSTER_EMOTE(message)
	if(SystemActive)then
		if(string.match(message, "Amphitheater of Annihilation")) then
			table.insert(Alert_Variables.Alerts, {Event="AoA",Time=0, Current=0, Players=PlayersInAshran(availablePlayers)})
		elseif(string.match(message, "Ashmaul Burial Grounds")) then
			table.insert(Alert_Variables.Alerts, {Event="ABG",Time=0, Current=0, Players=PlayersInAshran(availablePlayers)})
		elseif(string.match(message, "Molten Quarry")) then
			table.insert(Alert_Variables.Alerts, {Event="MQ",Time=0, Current=0, Players=PlayersInAshran(availablePlayers)})
		elseif(string.match(message, "Brute's Rise")) then
			table.insert(Alert_Variables.Alerts, {Event="BR",Time=0, Current=0, Players=PlayersInAshran(availablePlayers)})
		end
	end
end
function events:PLAYER_LEAVING_WORLD()
	Alert_Variables.Alerts = {}
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "DeleteMe", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "DeleteMe", "PARTY")
	end
end
function events:ZONE_CHANGED_NEW_AREA()
	if(GetZoneText()=="Ashran")then
		print("AshranAlert Activated. '/AA_Help' for commands")
		InAshran=true
	else
		if(InAshran)then
			Alert_Variables.Alerts={}
			InAshran=false
			if (IsInRaid()) then
				SendAddonMessage("AshranAlert", "DeleteMe", "RAID")
			elseif (UnitInParty("player")) then
				SendAddonMessage("AshranAlert", "DeleteMe", "PARTY")
			end
		end
	end
end

AshranAlert:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...);
end);
for k, v in pairs(events) do
 AshranAlert:RegisterEvent(k);
end

SLASH_RW1, SLASH_RW2 = '/AA_RW', '/AA_RW';
function SlashCmdList.RW(msg, editbox)
	useRaidWarning=not useRaidWarning
	if(useRaidWarning) then
		print("Raid Warning Enabled")
	else
		print("Raid Warning Disabled")
	end
end

SLASH_Reset1, SLASH_Reset2 = '/AA_Alerts', '/AA_Alerts';
function SlashCmdList.Reset(msg, editbox)
	print("-----# Alerts: "..tostring(#Alert_Variables.Alerts).."-----")
	for i = 1, #Alert_Variables.Alerts do
		print("Event: "..Alert_Variables.Alerts[i].Event.."     # Players: "..tostring(#Alert_Variables.Alerts[i].Players))
		for x = 1, #Alert_Variables.Alerts[i].Players do
			print(">>> Player: "..Alert_Variables.Alerts[i].Players[x])
		end
	end
end


SLASH_Players1, SLASH_Players2 = '/AA_PLAYERS', '/AA_PLAYERS';
function SlashCmdList.Players(msg, editbox)
	for i = 1, #availablePlayers do
		print(availablePlayers[i])
	end
end

SLASH_Enable1, SLASH_Enable2 = '/AA_ENABLE', '/AA_Enable';
function SlashCmdList.Enable(msg, editbox)
	SystemActive=true
	print("AshranAlert Enabled")
end

SLASH_Disable1, SLASH_Disable2 = '/AA_DISABLE', '/AA_Disable';
function SlashCmdList.Disable(msg, editbox)
	SystemActive=false
	print("AshranAlert Disabled")
	Alert_Variables={Alerts = {},Active=false,Players={},Message=""}
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "DeleteMe", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "DeleteMe", "PARTY")
	end
end

SLASH_Help1, SLASH_Help2 = '/AA_Help', '/AA_Help';
function SlashCmdList.Help(msg, editbox)
	print("Thank you for using AshranAlert. Here is a list of '/' commands:")
	print(">> '/AA_RW' : Toggles use of Raid Warnings (default: Enabled)")
	print(">> '/AA_Alerts' : Displays the current Alert_Variables.Alerts and players assigned to them")
	print(">> 'AA_Players' : Displays list of current Party/Raid members using AshranAlert")
	print(">> 'AA_Enable' : Enables Alerting (default: Enabled)")
	print(">> 'AA_Disable' : Disables Alerting")
end

function UpdatePlayers()
	availablePlayers={(UnitName("Player").."-"..GetRealmName())}
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", "", "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", "", "PARTY")
	end
end

function AshranAlert(message,Player)
	if(Player==(UnitName("Player").."-"..GetRealmName())) then
		if (IsInRaid() and IsAssistOrLead() and useRaidWarning) then
			SendChatMessage(message,"RAID_WARNING",nil,"CHANNEL")
		elseif (IsInRaid()) then
			SendChatMessage(message,"RAID",nil,"CHANNEL")
		elseif (UnitInParty("player")) then
			SendChatMessage(message,"PARTY",nil,"CHANNEL")
		else
			SendChatMessage(message,"YELL",nil,"CHANNEL")
		end
	end
	
	Alert_Variables.Active=false
	Alert_Variables.Players={}
	Alert_Variables.Message=""
end

function IsAssistOrLead()
	for i = 1,GetNumGroupMembers(),1 do
		name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
		if (name==UnitName("player") and (rank==1 or rank==2)) then
			return true
		end
	end
	return false
end

local function onUpdate(self,elapsed)
	if(InAshran)then
		Vote_Variables.VoteTimer=Vote_Variables.VoteTimer+elapsed
		if(Vote_Variables.VoteTimer>0.5 and Alert_Variables.Active)then
			Alert_Variables.Active=false
			FinalizeVote(Alert_Variables.Message)
		end
		CheckOffline()
		for i, alert in ipairs(Alert_Variables.Alerts) do
			alert.Time = alert.Time + elapsed
			if (alert.current~=math.floor(alert.Time)) then
				alert.current=math.floor(alert.Time)
				if alert.current == 0 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": 3 Minutes"}
					GetPlayerVote()
				end
				if alert.current == 60 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": 2 Minutes"}
					GetPlayerVote()
				end
				if alert.current == 120 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": 1 Minute"}
					GetPlayerVote()
				end
				if alert.current == 150 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": 30 Seconds"}
					GetPlayerVote()
				end	
				if alert.current == 165 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": 15 Seconds"}
					GetPlayerVote()
				end	
				if alert.current == 180 then
					Alert_Variables={Alerts=Alert_Variables.Alerts,Active=true,Players=PlayersInAshran(alert.Players),Message=alert.Event..": Starting NOW!"}
					GetPlayerVote()
					table.remove(Alert_Variables.Alerts, i)
				end
				if alert.current > 180 then
					table.remove(Alert_Variables.Alerts, i)
				end
			end
		end
	end
end

function PlayersInAshran(Players)	
	playersInAshran={}
	if (IsInRaid() or (UnitInParty("player"))) then
		for i = 1, #Players do
			if (not setContains(playersInAshran, Players[i])) then
				for x = 1, GetNumGroupMembers() do
					local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, loot = GetRaidRosterInfo(x)
					
					if(not string.match(name, "-")) then
						name=name.."-"..GetRealmName()
					end
					if(name==Players[i] and setContains({"Ashran","Amphitheater of Annihilation","Ashmaul Burial Grounds","Molten Quarry","Brute's Rise","Ring of Conquest","The Crossroads","Emberfall Tower","Volrath's Advance","Warspear Outpost","Warspear Infirmary","The Dark Woods","Seat of Kor'lox","Archmage Overwatch","Tremblade's Vanguard","Gorian Falls","Kings' Rest","Stormshield Stronghold","Stormshield Keep","Road of Glory","Ogre Mine","Crestfall Rise","Emberfall Watch"},zone)) then
						table.insert(playersInAshran, Players[i])
					end
				end
			end
		end
	else
		table.insert(playersInAshran,(UnitName("Player").."-"..GetRealmName()))
	end
	return playersInAshran
end

function GetPlayerVote()
	Vote_Variables.VoteTimer=0
	Vote_Variables.Vote={}
	Vote_Variables.Voted={}
	Vote_Variables.VoteCount=0
	if (IsInRaid()) then
		SendAddonMessage("AshranAlert", (Alert_Variables.Players[math.random(#Alert_Variables.Players)]..","..Alert_Variables.Message), "RAID")
	elseif (UnitInParty("player")) then
		SendAddonMessage("AshranAlert", (Alert_Variables.Players[math.random(#Alert_Variables.Players)]..","..Alert_Variables.Message), "PARTY")
	else
		SendAddonMessage("AshranAlert", (Alert_Variables.Players[math.random(#Alert_Variables.Players)]..","..Alert_Variables.Message), "WHISPER", (UnitName("Player").."-"..GetRealmName()))
	end
end

function FinalizeVote(Message)
	local player={}
	local playerVote=0
	for k, v in pairs(Vote_Variables.Vote) do
		if(setContains(Vote_Variables.Voted,k))then
			if (player=={} or v>playerVote) then
				player={k}
				playerVote=v
			elseif (v==playerVote) then
				table.insert(player, k)
			end
		end
	end
	if(#player>0)then
		table.sort(player)
		AshranAlert(Message, player[1])
	else
		AshranAlert(Message, (UnitName("Player").."-"..GetRealmName()))
	end
end

function CheckOffline()
	CheckOffline_Variables.Old, CheckOffline_Variables.New = CheckOffline_Variables.New, CheckOffline_Variables.Old
	wipe(CheckOffline_Variables.New)
	for i = 1, GetNumGroupMembers() do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, loot = GetRaidRosterInfo(i)
		if(name) then
			CheckOffline_Variables.New[name] = online or false
		end
	end
	for name, online in pairs(CheckOffline_Variables.New) do
		if not online and CheckOffline_Variables.Old[name] then
			if(not string.match(name, "-")) then
				name=name.."-"..GetRealmName()
			end
			for i = 1,#Alert_Variables.Alerts do
				for x = 1, #Alert_Variables.Alerts[i].Players do
					if (Alert_Variables.Alerts[i].Players[x]==name) then
						table.remove(Alert_Variables.Alerts[i].Players, x)
					end
				end
			end
			UpdatePlayers()
		elseif(#CheckOffline_Variables.Old>0 and online and not CheckOffline_Variables.Old[name]) then
			UpdatePlayers()
		end
	end
end

function setContains(set, key)
	NoUser=false
	for i = 1, #set do
		if (set[i]==key) then
			NoUser = true
		end
	end
    return NoUser
end

local f = CreateFrame("frame")
f:SetScript("OnUpdate", onUpdate)